#!/usr/bin/env python3

import mido, sys

def get_freq(note):
    a4 = 57
    a = 1.059463094359
    offset = 0
    if note > 57:
        offset = note - a4
    else:
        offset = (a4 - note) * (-1);

    return 440.0 * (a**offset)

mf = mido.MidiFile(sys.argv[1])

transpose = 0

if len(sys.argv) > 2:
    transpose = int(sys.argv[2])

freqs = []
times = []

cur_note = 0
for x in mf:
    if x.type == 'note_on':
        freqs.append(-1)
        times.append(int(x.time * 1000000))
        freqs.append(get_freq(x.note + transpose))
    elif x.type == 'note_off':
        times.append(int(x.time * 1000000))


print('// monkey island theme')
print('float monkey_notes[] = {')
print(','.join(str(x) for x in freqs))
print(',0 };')
print('uint32_t monkey_times[] = {')
print(','.join(str(x) for x in times))
print(',40 };')


